unit UControlleur;

interface

uses SysUtils, Graphics, Dialogs;

const JOUEURJAUNE = 1;
      JOUEURROUGE = -1;
      CASEVIDE = 0;
      JETONJAUNE : TColor = clYellow;
      JETONROUGE : TColor = clRed;
      SANSJETON : TColor = clWhite;

procedure initialisation;
procedure coupJoue(const x:byte);
procedure deplacerJeton;
procedure statutPartie;
procedure annulerDernierCoup;
function getJoueurCourant : integer;
function getCouleur(const x,y:byte) : TColor;

implementation

uses UModele, UVue;

var joueurCourant: integer;
    dernierCoupX, dernierCoupY,
    nbJetonsRestants,
    scoreJaune, scoreRouge: cardinal;

procedure initialisation;
begin
   initialise;
   nbJetonsRestants := 42;
   joueurCourant := getJoueurCourant;
   with FormPrincipale.LabelJoueurCourant do
      if joueurCourant = JOUEURJAUNE then
         begin
            Font.Color := clYellow;
            Caption := 'Les jaunes commencent';
         end
      else
         begin
            Font.Color := clRed;
            Caption := 'Les rouges commencent';
         end;
end;

procedure coupJoue(const x:byte);
var coupValide: boolean;
begin
   coupValide := (getGrilleElem(x,0) = CASEVIDE);
   if coupValide then
      begin
         dec(nbJetonsRestants);
         dernierCoupX := x;
         dernierCoupY := 0;
         setGrilleElem(x,0,joueurCourant);
         FormPrincipale.Timer1.Enabled := true;
         FormPrincipale.DrawGrid1.Enabled := false;
      end;
end;

procedure deplacerJeton;
begin
   if (getGrilleElem(dernierCoupX,dernierCoupY+1) = CASEVIDE)
      and (dernierCoupY < NB_RANGEES-1) then
         begin
            setGrilleElem(dernierCoupX,dernierCoupY+1,joueurCourant);
            setGrilleElem(dernierCoupX,dernierCoupY,CASEVIDE);
            inc(dernierCoupY);
         end
   else statutPartie;
end;

procedure statutPartie;
begin
   with FormPrincipale do
      begin
         Timer1.Enabled := false;
         if gagnant(joueurCourant) then
            begin
               if joueurCourant = JOUEURJAUNE then
                  begin
                     showmessage('Les jaunes ont gagn !'#13#10#10'F1 pour rejouer/ F2 pour quitter');
                     inc(scoreJaune);
                     LabelJaune.Caption := 'Score: ' + inttostr(scoreJaune);
                  end
               else
                  begin
                     showmessage('Les rouges ont gagn !'#13#10#10'F1 pour rejouer/ F2 pour quitter');
                     inc(scoreRouge);
                     LabelRouge.Caption := 'Score: ' + inttostr(scoreRouge);
                  end;
               NouvellePartie1.Enabled := true;
               Annulerderniercoup1.Enabled := false;
            end
         else
            if nbJetonsRestants = 0 then
               begin
                  NouvellePartie1.Enabled := true;
                  Annulerderniercoup1.Enabled := false;
                  showmessage('Personne ne gagne !');
               end
            else
               begin
                  joueurCourant := -(joueurCourant);
                  Annulerderniercoup1.Enabled := true;
                  DrawGrid1.Enabled := true;
                  with LabelJoueurCourant do
                     if joueurCourant = JOUEURJAUNE then
                        begin
                           Font.Color := clYellow;
                           Caption := 'Les jaunes jouent';
                        end
                     else
                        begin
                           Font.Color := clRed;
                           Caption := 'Les rouges jouent';
                        end;
               end;
      end;
end;

procedure annulerDernierCoup;
begin
   inc(nbJetonsRestants);
   setGrilleElem(dernierCoupX,dernierCoupY,CASEVIDE);
   FormPrincipale.DrawGrid1.Repaint;
   joueurCourant := -(joueurCourant);
   with FormPrincipale.LabelJoueurCourant do
      if joueurCourant = JOUEURJAUNE then
         begin
            Font.Color := clYellow;
            Caption := 'Les jaunes rejouent';
         end
      else
         begin
            Font.Color := clRed;
            Caption := 'Les rouges rejouent';
         end;
   FormPrincipale.Annulerderniercoup1.Enabled := false;
end;

function getJoueurCourant : integer;
begin
   if (scoreJaune + scoreRouge) mod 2 = 0 then result := JOUEURJAUNE
   else result := JOUEURROUGE;
end;

function getCouleur(const x,y:byte) : TColor;
begin
   case getGrilleElem(x,y) of
      JOUEURJAUNE: result := JETONJAUNE;
      JOUEURROUGE: result := JETONROUGE;
      else result := SANSJETON;
      end;
end;

end.
